
package fr.fluxmedia.transmorpher.Interface ;

import fr.fluxmedia.transmorpher.TProcessFactory.TProcessComposite ;
import fr.fluxmedia.transmorpher.TProcessFactory.TProcess ;

import javax.swing.JFrame;
import javax.swing.JPanel;
import java.awt.Graphics2D;
import java.awt.Graphics;
import java.awt.Color ;
import java.awt.Rectangle;
import java.awt.Polygon;


/**
  *
  *
  *
  *
  */

public final class DisplayingProcess {

  TProcessComposite iXSLT_Comp = null;
  JFrame iFrame = new JFrame("Process Visualizer ");
  JPanel iDrawPanel = new JPanel(true);

  public DisplayingProcess (TProcessComposite  iXSLT_Comp) {
    iFrame.getContentPane().add(iDrawPanel);
    iFrame.getContentPane().setLayout(null);
    iFrame.setSize(740,300);
    iFrame.setVisible(true);
    iDrawPanel.setSize(730,290);
    iDrawPanel.setLocation(5,5);
    iDrawPanel.setLayout(null);

    DrawReader(10,100,50,25);
    DrawMultiplexer(100,100,50,50); DrawLink(60,110,105,120);
    
    DrawTransformer(200,150,50,25); DrawLink(145,135,205,160);
    DrawMultiplexer(300,150,50,50); DrawLink(245,160,315,170);    

    DrawTransformer(375,175,50,25); DrawLink(345,180,385,187);    
    DrawTransformer(450,175,50,25); DrawLink(415,187,450,187);    
    DrawWriter(550,175,50,25);      DrawLink(495,187,560,187);    
 
    DrawTransformer(375,125,50,25); DrawLink(345,160,385,135); 
    DrawTransformer(450,125,50,25); DrawLink(415,135,455,135);
    DrawWriter(550,125,50,25);      DrawLink(495,137,560,137);   

    DrawTransformer(200,50,50,25); DrawLink(145,105,205,60);
    DrawTransformer(300,50,50,25); DrawLink(245,60,305,60);
    DrawTransformer(400,50,50,25); DrawLink(345,60,405,60);       
    DrawWriter(500,50,50,25);      DrawLink(445,60,505,60);

  /*  DrawLink(1,10,600,10);
      DrawLink(100,5,100,15); DrawLink(150,8,150,12);
      DrawLink(200,5,200,15); DrawLink(250,8,250,12);
      DrawLink(300,5,300,15); DrawLink(350,8,350,12);
      DrawLink(400,5,400,15); DrawLink(450,8,450,12);
      DrawLink(500,5,500,15); DrawLink(550,8,550,12);
      DrawLink(600,5,600,15);                        
   */
  }




  void DrawConnector(int X,int Y,int W,int H) {
     iDrawPanel.add(new ConnectorPanel(X,Y,W,H));
  }
  void DrawMultiplexer(int X,int Y,int W,int H) {
     iDrawPanel.add(new MultiplexerPanel(X,Y,W,H));
  }
  void DrawTransformer(int X,int Y,int W,int H) {
     iDrawPanel.add(new TransformerPanel(X,Y,W,H));
  }
  void DrawWriter(int X,int Y,int W,int H) {
     iDrawPanel.add(new WriterPanel(X,Y,W,H));
  }
  void DrawReader(int X,int Y,int W,int H) {
     iDrawPanel.add(new ReaderPanel(X,Y,W,H));
  }
 void DrawLink(int X,int Y,int W,int H) {
     iDrawPanel.add(new LinkPanel(X,Y,W,H));
  }


}
