/**
 * $Id: FMParser.java,v 1.12 2001/06/12 15:50:30 gchomat Exp $
 *
 * Transmorpher
 * 
 * Copyright (C) 2001 Fluxmedia and INRIA Rhne-Alpes.
 *
 * http://www.fluxmedia.fr - http://transmorpher.inrialpes.fr
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
/**
   Author  : Laurent Tardif
   Date    : 05 01 2001
   Content : Define a parser for XML Document

*/

package fr.fluxmedia.transmorpher.Parser ;


// Imported SAX Classes 

import org.xml.sax.Attributes;
//import org.xml.sax.helpers.ParserFactory;//deprecated
import org.xml.sax.helpers.DefaultHandler;
//import org.xml.sax.Parser;//deprecated
import org.xml.sax.SAXException ;
import org.xml.sax.SAXParseException; 
import org.xml.sax.helpers.XMLFilterImpl; 

//Imported JAVA Classes

import java.util.Stack ;


/**
   Author  : Laurent Tardif
   Date    : 05 01 2001
   Content : Define a parser for XML Document
   
*/
public class FMParser
    extends DefaultHandler {
    
    /** The XML Parser class */
    private static final String
        DEFAULT_PARSER_NAME = "com.ibm.xml.parsers.SAXParser";

    
    /** XML Parser */
    javax.xml.parsers.SAXParser iParser = null;
    
    /** The current context of the parsing*/
    Stack iContext = null ;
    
    
    /*------------------------------------------ CONSTRUCTOR -----------------------------*/
    
    /** The constructor, build the XML PArser but not parse the document */
    public FMParser() {
	try {
	    javax.xml.parsers.SAXParserFactory iParserFactory =javax.xml.parsers.SAXParserFactory.newInstance();

	    iParserFactory.setValidating(true);
	    iParserFactory.setNamespaceAware(true);
	    iParser = iParserFactory.newSAXParser();

	}  catch (javax.xml.parsers.ParserConfigurationException CNFE) {
	    System.out.println("FMParser :Error [" + CNFE +"]");
	}  catch (org.xml.sax.SAXException SaxE) {
	    System.out.println("FMParser :Error [" + SaxE +"]");
	}  
    }

    /*------------------------------------------- END CONSTRUCTOR ------------------------*/
    
  /** Parse the document given in parameter */
  public final void parse(String uri) {
    iContext = new Stack ();
 
    try {
	iParser.parse(uri,this);
    } catch (SAXException SE) {
	System.out.println("[FMParser]Erreur SAX(" + SE+")");
	System.out.println("[FMParser]Erreur SAX(" + SE.getMessage()+")");
	System.out.println("[FMParser]Erreur SAX(" + SE.getException()+")");
	SE.printStackTrace();
    } catch (java.io.IOException IOE) {
	System.out.println("[FMParser]Erreur IO(" + IOE+")");
    }
   }
    
    public void warning(SAXParseException exception)
      throws SAXException
    {
	System.out.println("warning");
    }
    
    public void error(SAXParseException ex) 
    {
	System.err.print("Error!! "); 
	System.err.println(ex); 
    }
    
    public void fatalError(SAXParseException ex) throws SAXException 
    { 
	System.err.print("Fatal Error!! ");
	System.err.println(ex); 
    } 
}
