/**
 * $Id: ParserAnswer.java,v 1.8 2001/06/12 15:50:30 gchomat Exp $
 *
 * Transmorpher
 * 
 * Copyright (C) 2001 Fluxmedia and INRIA Rhne-Alpes.
 *
 * http://www.fluxmedia.fr - http://transmorpher.inrialpes.fr
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

/**
  * Content : Define a class to store usefull parser information
  * for ProcessDescription file
  * @Author  : Laurent Tardif
  * @Date    : 05 01 2001
*/


package fr.fluxmedia.transmorpher.Parser ;


public final class ParserAnswer {
  
    
    /** The identifier of this element */
    String iId = null ;
    
    /** Store  the name */
    String iName = null;
    
    /** Store the liste of in XML_PORT*/
    String[] iIn = new String[0];
    
    /** Store the liste of OUT XML_PORT*/
    String[] iOut = new String[0];
    
    /** The filename */
    String iFilename = null;
    
    /** the reference Object */
    String iRefOn = null;
    
    /** The type of the element*/
    String iType = null;
    
    /** The number of iteration for loop, the infinity constant is defined in the TProcessFactory */
    int iCount = 0;
  
    /** The strategy for apply the ruleset */
    String iStrategy=null;

    /** Build a new ParserAnswer */
    public ParserAnswer() {
    }
    
    /** get the id */
    public final String getId(){
	return iId;
    }
    
    /** set the id */
    public final void setId(String id){
	iId=id;
    }

    /** get the name */
    public final String getName() {
	return iName;
    }
    
    /** set the name */
    public final void setName(String pName) {
	iName=pName;
    }
    
    /** get the ref */
    public final String getRefOn() {
	return iRefOn;
    }
    
    /** set the ref */
    public final void setRefOn(String pRefOn) {
	iRefOn=pRefOn;
  }
    
    /** set the in XML_Port name */
    public final void setIn(String[] pIn) {
	iIn=pIn;
    }
    
    /** get the in Port name */
    public final String[] getIn() {
	return iIn;
    }
    
    /** set the out port */
    public final void setOut(String[] pOut) {
	iOut=pOut;
    }
    
    /** get the out port */
    public final String[] getOut () {
	return iOut;
    }
    
    /** get the filename */
    public final String getFilename() {
	return iFilename;
    }
    
    /** set the filename */
    public final void setFilename(String pFilename) {
	iFilename=pFilename;
    }
    
    /** get the filename */
    public final String getType() {
	return iType;
    }
    
    /** set the filename */
    public final void setType(String pType) {
	iType=pType;
    }
    
    public final void setCount(int pCount) {
	iCount = pCount ;
    }
    
    public final int getCount() {
	return iCount ;
    }
    
     public final String getStrategy() {
	return iStrategy;
    }
    
    /** set the strategy */
    public final void setStrategy(String pStrategy) {
	iStrategy=pStrategy;
    }
  
}
