/**
 * $Id: QueryParser.java,v 1.5 2001/06/13 11:33:56 jerome Exp $
 *
 * Transmorpher
 * 
 * Copyright (C) 2001 Fluxmedia and INRIA Rhne-Alpes.
 *
 * http://www.fluxmedia.fr - http://transmorpher.inrialpes.fr
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
/**
Author  : Guillaume Chomat 
Date    : 05 28 2001

*/
package fr.fluxmedia.transmorpher.Parser ;


// imported SAX Classes 

import org.xml.sax.Attributes;

//Imported JAVA CLasses

import java.util.Vector;


//Imported Transmorpher CLasses 

import fr.fluxmedia.transmorpher.Files.ReadWrite ;
import fr.fluxmedia.transmorpher.Files.Constants ;


public final class QueryParser {


/**
  *
  *
  * Construction of stylesheet
  *
  *
  **/

    public static final String listAttribute(Attributes atts){
	String listAttribute="";
	if (atts.getLength()!=0)
	{
	    for(int i=0 ; i<atts.getLength() ; i++){
		listAttribute=listAttribute+atts.getLocalName(i)+"=\""+atts.getValue(i)+"\" ";
	    }

	}

	    return listAttribute;
    }

  /** Allow to define rule set, this definition build a XSL file */
  public static final ReadWrite startDefineQuery(Attributes attrs) {
    
      //System.out.println("START FILE");
    ReadWrite FileRW = new ReadWrite(attrs.getValue("name")+".xsl",Constants.WRITE); 
    FileRW.Writeln("<?xml version=\"1.0\"?>");
    FileRW.Writeln("<xsl:stylesheet xmlns:xsl=\"http://www.w3.org/1999/XSL/Transform\" version=\"1.0\">");
    FileRW.Writeln("");
    FileRW.Writeln("<!-- ************************************************************ -->");
    FileRW.Writeln("<!--                                                              -->");
    FileRW.Writeln("<!-- This style sheet was generated by the FluxMdia Transmorpher -->");
    FileRW.Writeln("<!--                                                              -->");
    FileRW.Writeln("<!-- ************************************************************ -->");
    FileRW.Writeln("");
    FileRW.Writeln("  <xsl:template match=\"/\">");
    FileRW.Writeln("<"+attrs.getValue("root")+">");
    FileRW.Writeln("    <xsl:apply-templates select=\"*\"/>");
    FileRW.Writeln("</"+attrs.getValue("root")+">");
    FileRW.Writeln("  </xsl:template>");
    FileRW.Writeln("");
    FileRW.Writeln("  <xsl:template match=\"text()\"/>");
    FileRW.Writeln("");
    
    return FileRW ;
  }

    /** Allow to define a basic selection:
	<select expr="x" />
    */
    public static final void startSelect(ReadWrite iXslFile,Attributes attrs){
	iXslFile.Writeln(2,"<!-- Selection -->");  
	iXslFile.Writeln(2,"<xsl:template match=\""+attrs.getValue("match")+"\">");
	iXslFile.Writeln(4,"<xsl:copy-of select=\".\"/>");
	iXslFile.Writeln(2,"</xsl:template>");
	iXslFile.Writeln("");
  }

    
    public static final void endSelect(ReadWrite iXslFile){
	
	// do nothing for the moment

    }
 
    /** Allow to define a Parameter for the query:
	<param name="x" [select="expression"]>...</param>
    */

    public static final void startParam(ReadWrite iXslFile,Attributes attrs){
			   
	iXslFile.Writeln(2,"<!-- Parameter -->");  
	iXslFile.Writeln(2,"<xsl:param "+listAttribute(attrs)+">");
	

  }
    
    public static final void endParam(ReadWrite iXslFile){
	
	iXslFile.Writeln(2,"</xsl:param>");
	iXslFile.Writeln("");
    }
    /** close the iXlFile */
    public static final void endDefineQuery(ReadWrite iXslFile) {
	iXslFile.Writeln("</xsl:stylesheet>") ;
	iXslFile.Close();    
    }


}//end class
