/**
 * $Id: TQuery.java,v 1.6 2001/06/12 12:53:13 gchomat Exp $
 *
 * Transmorpher
 * 
 * Copyright (C) 2001 Fluxmedia and INRIA Rhne-Alpes.
 *
 * http://www.fluxmedia.fr - http://transmorpher.inrialpes.fr
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

package fr.fluxmedia.transmorpher.TProcessFactory ;

// Imported TraX classes

import javax.xml.transform.TransformerFactory;
import javax.xml.transform.stream.StreamSource;
import javax.xml.transform.TransformerException;
import javax.xml.transform.TransformerConfigurationException;
import javax.xml.transform.sax.SAXTransformerFactory;
import javax.xml.transform.sax.TransformerHandler;
import javax.xml.transform.sax.SAXSource;
import javax.xml.transform.sax.SAXResult;

// Imported SAX Classes 

import org.xml.sax.Attributes;
import org.xml.sax.helpers.DefaultHandler;
import org.xml.sax.helpers.XMLReaderFactory;
import org.xml.sax.XMLReader;
import org.xml.sax.SAXException ;

// Imported java.io classes

import java.io.IOException;

//Imported Transmorpher CLasses 

import fr.fluxmedia.transmorpher.Files.ReadWrite ;
import fr.fluxmedia.transmorpher.Files.Constants ;
import fr.fluxmedia.transmorpher.Parser.QueryParser ;


public final class TQuery 
  extends DefaultHandler
  implements TProcess {

  ///////// Copy of the  TProcess Imp

  /** The number of max IN PORT */
    //  static final int MAX_IN    = 10;

  /** The number of max OUT PORT */
    //  static final int MAX_OUT   = 10;

  /** The In port */
  XML_Port [] iListIn = null;
  
  /** the current In port */
  int iNbIn = 0;
    
  /** The out PORT */  
  XML_Port [] iListOut = null ;
  
  /** The List of out port */
  int iNbOut =0 ;
  
  /** The name of the process */
  String iName = null;
  
  /////// end of  PRocess Impl
  


  private static final String
        DEFAULT_PARSER_NAME = "com.ibm.xml.parsers.SAXParser";

  /** XML Parser */
  javax.xml.parsers.SAXParser iParser = null;
  
  
  TTransformer iTransformer = null ;
    QueryParser qParser = null;
  
  ReadWrite FileRW = null;
  
  String iQueryFilename = null;
  String iRoot = null;
  /** The instance  constructor 
  
  @throws TransformerException
  @throws TransformerConfigurationException
  @throws SAXException
  @throws IOException
  
  */
    public TQuery (String type, String[] pIn, String[] pOut,String pQueryFilename) 
	throws TransformerException, TransformerConfigurationException, 
	SAXException, IOException	 {
	
	//// copy of the TProcess Impl
	iListIn=new XML_Port[pIn.length];
	iNbIn = pIn.length;
	iListOut=new XML_Port[pOut.length];
	iNbOut = pOut.length;
	///// end of the copy of the TProcess Impl
	iQueryFilename = pQueryFilename ;
	String file = iQueryFilename ;
	
	//Create the parser 
	if (type.equals("tmqfile"))
	    {
		//System.out.println(file + "  " + type);
		file=iQueryFilename+".xsl" ;
                qParser = new QueryParser();
		try {
		    //iParser = ParserFactory.makeParser(DEFAULT_PARSER_NAME);
		    iParser = javax.xml.parsers.SAXParserFactory.newInstance().newSAXParser() ;
		    iParser.parse(iQueryFilename,this);
		} catch (javax.xml.parsers.ParserConfigurationException CNFE) {
		    System.out.println("TQuery :Error [" + CNFE +"]");
		} catch (SAXException SE) {
		    System.out.println("[TQuery]Error SAX(" + SE+")");
		    System.out.println("[TQuery]Error SAX(" + SE.getMessage()+")");
		    System.out.println("[TQuery]Error SAX(" + SE.getException()+")");
		    SE.printStackTrace();
		} catch (java.io.IOException IOE) {
		    System.out.println("[TQuery]Erreur IO(" + IOE+")");
		}
		
		//super(pIn,pOut);
		//iTransformer = new TTransformer(pIn,pOut,iQueryFilename+".xsl");
		
	    }
	iTransformer=(TTransformer)TProcessFactory.newTransformer("xslt",pIn,pOut,file);
	iListIn = iTransformer.getIn();
	iListOut = iTransformer.getOut();
    } //End constructor  
  
  
  /** Call by the XML parser at the begining of an element */
  public final void startElement(String pName, Attributes attrs) {
    String vName = pName.toLowerCase();
    if (vName.equals("query")) {
	iRoot=attrs.getValue("root");
	FileRW = qParser.startDefineQuery(attrs);
    } else if (vName.equals("select")) {
        qParser.startSelect( FileRW, attrs);
    } else {
	System.out.println("startElement TQuery : Element inconnu : " + vName);
    }
  } //end proc startElement 
  
  /** Call by the XML parser at the begining of an element */
  public final void endElement(String pName) {
    String vName = pName.toLowerCase();
    if (vName.equals("query")) {
        qParser.endDefineQuery(FileRW);
    } else if (vName.equals("select")) {
        qParser.endSelect(FileRW);
    } else {
	System.out.println("startElement TQuery : Element inconnu : " + vName);
    }
  } //end proc startElement 
  
  //////Copy of the TProcess Impl
  
     
  /** Get the name of the process */  
  public final String getName() {
    return iName;
  }
  
  /** Set the name of the process*/
  public final void setName(String pName) {
    iName=pName;
  }
  
  /* set an In port */
  public final void setIn(int i,XML_Port pFileIn) {
    iListIn[i]=pFileIn;  
  }
  
  /** Set an Out Port */
  public final void setOut(int i,XML_Port pFileOut) {
    iListOut[i]=pFileOut;  
  }
  
  /** Get an In port */
  public final XML_Port getIn(int i) {
    return iListIn[i];
  }
  
  /** Get an Out Port */ 
  public final XML_Port getOut(int i) {
    return iListOut[i];
  }
  
  /** Get the In ports */
  public final XML_Port[] getIn() {
    return iListIn;
  }
  
  /** Get the Out Ports */ 
  public final XML_Port[] getOut() {
    return iListOut;
  }
  
  
  /** Create a copy of this element in the composite given in parameter */
  public final TProcess Copy(TProcessComposite vFather) {
    //System.out.println("COPY : " +getName());

    // Copy the element 
    TProcess vProcess = internalCopy();
    // Insert Unliked port in the father
    XML_Port[] In = vProcess.getIn();
    XML_Port[] Out = vProcess.getOut();
    
    vFather.addProcess(vProcess);
    for (int i=0; i<In.length; i++) {
      //System.out.println("[Process::Copy] + IN :"+ In[i].getName()+" : " +In[i]);
      //System.out.println("[Process::Copy] + IN :"+ In[i].getCompositeName()+" : " +In[i]);      
      vFather.InsertUnlinkedInPort(In[i].getCompositeName(),In[i]);
    }
    for (int i=0; i<Out.length; i++) {
      //System.out.println("[Process::Copy] + OUT :"+ Out[i].getName()+" : " +Out[i]);
      //System.out.println("[Process::Copy] + OUT :"+ Out[i].getCompositeName()+" : " +Out[i]);      
      vFather.InsertUnlinkedOutPort(Out[i].getCompositeName(),Out[i]);
    }
    return vProcess;
  }
  
  /** Copy the Query. only copy the transformer box, and use the same xsl file */
  public final TProcess internalCopy() {
    TQuery vAns =null;
    
    String[] vPortName = new String [getOut().length];
    XML_Port[] out = getOut();
    for (int i =0; i<vPortName.length; i++) {
      vPortName[i]=out[i].getCompositeName();
    }

    String[] vPortNameIn = new String [getIn().length];
    XML_Port[] in= getIn();
    for (int i =0; i<vPortNameIn.length; i++) {
      vPortNameIn[i]=in[i].getCompositeName();
    } 
  
   try {
    vAns = new TQuery("internal",vPortNameIn,vPortName, iQueryFilename);
   } catch (Exception e) {
      System.out.println("Erreur lors de la copy d'un TQuery");
   }
   return vAns;
  } 
  
  /////// end of   Copy of the TProcess Impl
     
}//end class

