/**
 * $Id: TReader.java,v 1.5 2001/06/12 15:50:30 gchomat Exp $
 *
 * Transmorpher
 * 
 * Copyright (C) 2001 Fluxmedia and INRIA Rhne-Alpes.
 *
 * http://www.fluxmedia.fr - http://transmorpher.inrialpes.fr
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
/**
 * This class provide a basic process which is
 * able to read an XML file
 *
 * @author Laurent.Tardif@inrialpes.fr
 * @since jdk 1.3 && SAX 2.0
 */

package fr.fluxmedia.transmorpher.TProcessFactory ;


// Imported SAX classes

import org.xml.sax.SAXException;
import org.xml.sax.helpers.XMLReaderFactory;
import org.xml.sax.XMLReader;

// Imported java.io classes

import java.io.IOException;


//For thread

import java.lang.Runnable ;

public final class TReader
  extends TProcessBasic 
    implements Runnable {
    
    /** The XMLReader */
    XMLReader iReader = null;
    boolean isThread = false ;
    
    /** The file name whish describe the file to read */
    String iFilename = null;
    
    boolean isRunning = false ;
    Thread myThread = null;
  
    
    /** The constructor */
    public TReader (String[] pOut, String pFilename)
	throws SAXException, IOException	 {
	super(new String[0],pOut);
	iFilename = pFilename;
	//System.out.println("{ TProcess] creation d un Reader");
	
	iReader = XMLReaderFactory.createXMLReader();
	iReader.setFeature("http://xml.org/sax/features/namespace-prefixes",true);
	iReader.setFeature("http://xml.org/sax/features/namespaces",true);
	
	iListOut[0] = new XML_Port(pOut[0],this,(XMLReader)iReader,0,XML_Port.OUT);
	if (isThread) myThread = new Thread(this);
    }
    
    /** Exec the process */
    public void execProcess() throws IOException,SAXException {
	if (isThread) { 
	    System.out.println("We hop that the link method has been call (Thread) ") ; //:-)
	    myThread.start();
	} else {
	    System.out.println("We hop that the link method has been call (no thread)") ; //:-)
	    iReader.parse(iFilename);  
	}
	//System.out.println("Fin de l'ordre de parse") ;
    }
    
    /** Copy this reader, this method is call by the Copy method of the XLTProcess_Impl */ 
    public final TProcess internalCopy() {
	try {
	    String[] vPortName = new String [getOut().length];
	    XML_Port[] out = getOut();
	    for (int i =0; i<vPortName.length; i++) {
		vPortName[i]=out[i].getCompositeName();
	    }
	    
	    TReader vAns = new TReader(vPortName, iFilename);
	    return vAns ;
	} catch (Exception e) {
	    System.out.println("Erreur lors de la copy d'un TReader : " +e);
	}
	return null;
    }
    
    public final void run() {
	//System.out.println("euh .. je fais qqc ?"); 
	if (!isRunning) {
	    try {
		//System.out.println("debut du parse  2"); 
		iReader.parse(iFilename);  
		//System.out.println("Fin du parse  2"); 
		isRunning=true;
		//myThread.interrupt();       
	    } catch (Exception e) {
		System.out.println("Fin du parse 2 !erreur dans le thread" + e); 
		isRunning=true;       
    }
	} //fin if
	
    } //end run

 
 
}
