/**
 * $Id: TSerializer.java,v 1.2 2001/06/12 15:50:30 gchomat Exp $
 *
 * Transmorpher
 * 
 * Copyright (C) 2001 Fluxmedia and INRIA Rhne-Alpes.
 *
 * http://www.fluxmedia.fr - http://transmorpher.inrialpes.fr
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
/**
  * This class offer a serializer mechanisme. A way to finish the transphormation process
  * bye writing XML output file
  *
  * @author laurent tardif@inrialpes.fr
  * @date 10 02 2001
  * @since jdk 1.3 && SAX 2.0
  */

package fr.fluxmedia.transmorpher.TProcessFactory ;

// Imported SAX classes

import org.xml.sax.SAXException;
import org.xml.sax.ContentHandler;

// Imported Serializer classes

import org.apache.xalan.serialize.Serializer;
import org.apache.xalan.serialize.SerializerFactory;
import org.apache.xalan.templates.OutputProperties;

// Imported java.io classes
import java.io.FileOutputStream;
import java.io.File;
import java.io.IOException;

public final class TSerializer 
  extends TProcessBasic{

  /** the serializer */
  Serializer serializer = null;
  
  String iXML_Filename = null;
    
  java.util.Properties Op = OutputProperties.getDefaultMethodProperties("xml");

  /** The constructor */
  public TSerializer (String[] pIn,String pFilename)  
    throws SAXException, IOException	 {
    super(pIn,new String[0]);
    //System.out.println("{ TProcess] creation d un serializer");
    iXML_Filename = pFilename ;

    if (pFilename.endsWith("html")) {
      Op = OutputProperties.getDefaultMethodProperties("xml");
    } else if (pFilename.endsWith("xml")) {
      Op = OutputProperties.getDefaultMethodProperties("xml");
    } else if (pFilename.endsWith("bib")) {
      Op = OutputProperties.getDefaultMethodProperties("text");
    }


    
    Op.setProperty("encoding","iso-8859-1");
    
    serializer = SerializerFactory.getSerializer(Op);   
     
    FileOutputStream FOS =  new FileOutputStream(new File(pFilename));
    serializer.setOutputStream(FOS);
    iListIn[0]=new XML_Port(pIn[0],this,(ContentHandler)serializer.asContentHandler(),0,XML_Port.IN);
  } //end constructor 
  
  
  /** Copy this component */
  public final TProcess internalCopy() {
    try {
      String[] vPortNameIn = new String [getIn().length];
      XML_Port[] in= getIn();
      for (int i =0; i<vPortNameIn.length; i++) {
        vPortNameIn[i]=in[i].getCompositeName();
      } 
      TProcess vAns = new TSerializer(vPortNameIn,iXML_Filename);
      return vAns ;
    } catch (Exception E) {
      // SAXException, IOException
      System.out.println("Erreur lors de la copie d'un TSerializer");
    }
    return null;
  }
   

} //end class
