/**
 * $Id: TTransformer.java,v 1.4 2001/06/12 15:50:30 gchomat Exp $
 *
 * Transmorpher
 * 
 * Copyright (C) 2001 Fluxmedia and INRIA Rhne-Alpes.
 *
 * http://www.fluxmedia.fr - http://transmorpher.inrialpes.fr
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
/**
  * 
  * This class allow to build a Transformer process
  *
  * @author Laurent Tardif (laurent.tardif@inrialpes.fr)
  * @since jdk 1.2 / SAX 2.0
  * @see fr.fluxmedia.transmorpher.TProcessFactory.XML_Port
*/

package fr.fluxmedia.transmorpher.TProcessFactory ;

// Imported TraX classes

import javax.xml.transform.TransformerFactory;
import javax.xml.transform.stream.StreamSource;
import javax.xml.transform.TransformerException;
import javax.xml.transform.TransformerConfigurationException;
import javax.xml.transform.sax.SAXTransformerFactory;
import javax.xml.transform.sax.TransformerHandler;
import javax.xml.transform.sax.SAXSource;
import javax.xml.transform.sax.SAXResult;

// Imported SAX classes

import org.xml.sax.SAXException;


// Imported java.io classes

import java.io.IOException;

public class TTransformer 
  extends TProcessBasic{

  /** The transformer */  
  TransformerHandler iTransformerHandler = null;
  
  /** The XslFile, it's the parameter of the transformation */
  String XSLFile = null;
  
  /** the properties for all transformer */
  static java.util.Properties Op = null ;
  
  /** The instance  constructor 
  
  @throws TransformerException
  @throws TransformerConfigurationException
  @throws SAXException
  @throws IOException
  
  */
  
  public TTransformer (String[] pIn, String[] pOut,String XSLName) 
    throws TransformerException, TransformerConfigurationException, 
           SAXException, IOException	 {
    super(pIn,pOut);

    XSLFile=XSLName; 
    StreamSource SS = new StreamSource("./"+XSLName) ;
   // Create a TransformerHandler for each stylesheet.
    iTransformerHandler = TProcessFactory.getSAXTFactory().newTransformerHandler(SS); 
    if (Op == null) {
      Op =  iTransformerHandler.getTransformer().getOutputProperties();
      Op.setProperty(javax.xml.transform.OutputKeys.ENCODING,"iso-8859-1");
      Op.setProperty(javax.xml.transform.OutputKeys.INDENT,"yes");
      Op.setProperty(javax.xml.transform.OutputKeys.METHOD,"xml");    
    } //end if 
     iTransformerHandler.getTransformer().setOutputProperties(Op);      
     
   //Create the in and out port
   iListIn [0] = new XML_Port(pIn[0],this,iTransformerHandler,0,XML_Port.IN);
   iListOut[0] = new XML_Port(pOut[0],this,iTransformerHandler,0,XML_Port.OUT);
     
  } //End constructor  
  
  /** get The Transformer Handler */
  public final TransformerHandler getTransformerHandler() {
    return iTransformerHandler;
  }

  /** Copy the transfomer. The method is called by theCopy method
      of the TProcess_impl class */  
      
  public final TProcess internalCopy() {
    TTransformer vAns =null ;
    String[] vPortName = new String [getOut().length];
    XML_Port[] out = getOut();
    for (int i =0; i<vPortName.length; i++) {
      vPortName[i]=out[i].getCompositeName();
    }

    String[] vPortNameIn = new String [getIn().length];
    XML_Port[] in= getIn();
    for (int i =0; i<vPortNameIn.length; i++) {
      vPortNameIn[i]=in[i].getCompositeName();
    }    
    
    try {
      vAns = new TTransformer(vPortNameIn,vPortName,XSLFile);
    } catch(Exception e) {
      System.out.println("Error during the copy of a TTransformer : "+e);
    }
    return vAns ;
  }
    
}//end class
